#######################################################################
###        pTk Wightñ˰٤Υ饹                          ###
###        Easy Wight Class                                         ###
#######################################################################

#######################################################################
# Entry֥                                                   #
#######################################################################
package entry;

# 󥹥ȥ饯
sub new {
    my $self = {};
    shift(@_);
    my $parent = shift(@_);
    my $title = shift(@_);

    my $w_frame = $parent->Frame;
    $w_frame->pack(-side=>top,-fill=>x);
    my $w_title = $w_frame->Label(-text=>$title,-width=>10,-anchor=>nw);
    $w_title->pack('-side'=>left,'-fill'=>x);

    $self->{entry} = $w_frame->Entry('-width'=>40);
    ($self->{entry})->pack('-side'=>left,'-fill'=>x);
    bless $self;
}

# ǡκ
sub delete {
    my $self = shift(@_);

    ($self->{entry})->delete(0,end);
}

# ǡΥå
sub set {
    my $self = shift(@_);
    my $data = shift(@_);
    &delete($self);
    ($self->{entry})->insert(0,$data);
}

# ǡμФ
sub get {
    my $self = shift(@_);
    return ($self->{entry})->get;
}

#######################################################################
# Hidden֥                                                   #
#######################################################################
package hidden;

# 󥹥ȥ饯
sub new {
    my $self = {};
    shift(@_);
    my $parent = shift(@_);
    my $title = shift(@_);
    bless $self;
}

# ǡκ
sub delete {
    my $self = shift(@_);
    ($self->{hidden}) = "";
}

# ǡΥå
sub set {
    my $self = shift(@_);
    my $data = shift(@_);
    ($self->{hidden}) = $data;
}

# ǡμФ
sub get {
    my $self = shift(@_);
    return ($self->{hidden});
}

#package tasklist::select;

#######################################################################
# ñradiobutton֥                                         #
#######################################################################
package radiobutton;

# 󥹥ȥ饯
sub new {
    shift(@_);
    my $parent = shift(@_);
    my $title = shift(@_);
    my %data = @_;

    my $w_frame = $parent->Frame;
    $w_frame->pack(-side=>top,-fill=>x);
    my $w_title = $w_frame->Label(-text=>$title,-width=>10,-anchor=>nw);
    $w_title->pack('-side'=>left,'-fill'=>x);

    my $w_radio = $w_frame->Frame;
    $w_radio->pack('-side'=>'left',-fill=>x);

    my $self = {};
    while(($key,$value)= each(%data)) {
	$w_radio->Label('-text'=>$key)->pack('-side'=>left);
	$w_radio->Radiobutton(-value=>$value,-variable=>\$self{radio})->pack('-side'=>left);
    }
    bless {};
}

# ǡκ
sub delete {
    my $self = shift(@_);

    $self{radio} = "";
}

# ǡΥå
sub set {
    my $self = shift(@_);
    $self{radio} = shift(@_);
}

# ǡμФ
sub get {
    my $self = shift(@_);
    return $self{radio};
}

#######################################################################
# ե֥                                                   #
#######################################################################
package date;

# 󥹥ȥ饯
sub new {
    shift(@_);
    my $parent = shift(@_);
    my $title = shift(@_);

    my $w_frame = $parent->Frame;
    $w_frame->pack(-side=>top,-fill=>x);
    my $w_title = $w_frame->Label(-text=>$title,-width=>10,-anchor=>nw);
    $w_title->pack('-side'=>left,'-fill'=>x);

    my $self = {};
    my $w_date = $w_frame->Frame('-relief'=>sunken);
    $w_date->pack('-side'=>'left',-fill=>x);
    $self->{year} = $w_date->Entry('-width'=>2,'-relief'=>flat);
    ($self->{year})->pack('-side'=>left,'-fill'=>x);
    $w_date->Label('-text'=>'/')->pack('-side'=>left);
    $self->{mon} = $w_date->Entry('-width'=>2,'-relief'=>flat);
    ($self->{mon})->pack('-side'=>left,'-fill'=>x);
    $w_date->Label('-text'=>'/')->pack('-side'=>left);
    $self->{day} = $w_date->Entry('-width'=>2,'-relief'=>flat);
    ($self->{day})->pack('-side'=>left,'-fill'=>x);

    ($self->{year})->bind('/'=>sub {print "year\n";});
    ($self->{mon})->bind('/'=>sub {print "mon\n";});
    ($self->{day})->bind('/'=>sub {print "day\n";});

    bless $self;
}

#ǡκ
sub delete {
    my $self = shift(@_);

    ($self->{year})->delete(0,end);
    ($self->{mon})->delete(0,end);
    ($self->{day})->delete(0,end);
}

# ǡΥå
sub set {
    my $self = shift(@_);
    &delete($self);
    $_ = shift(@_);

    /(\d*)-(\d*)-\d\d(\d*)/ && do {
	($self->{year})->insert(0,$3);
	($self->{mon})->insert(0,$2);
	($self->{day})->insert(0,$1);
    }
}

# ǡμФ
sub get {
    my $self = shift(@_);

    my $year = ($self->{year})->get;
    my $mon  = ($self->{mon})->get;
    my $day  = ($self->{day})->get;

    return "$day-$mon-19$year"
}

#######################################################################
# ꥹȥ֥                                                    #
#######################################################################
package listbox;

sub new {
    shift(@_);
    my $parent = shift(@_);
    my $self = {};

    $self->{w_listbox} = $parent->ScrlListbox(-scrollbars=>sw,-height=>8,-width=>20);
    ($self->{w_listbox})->pack(-side=>left);
    bless $self;
}

# Scrollbarindex򥻥åȤ롣
sub set {
    my $self  = shift(@_);
    my $pg    = shift(@_);
    my $title = shift(@_);
    my $number = shift(@_);
    my %line  = ();

    my @index = ();
    my %number = ();
    $self->{index} = \@index;
    $self->{number} = \%number;
    ($self->{w_listbox})->delete(0,end);

    my $count = 0;
    while(1) {
	%line = $pg->get_line_assoc_array;
	if ($pg->error) {last;}
	&add($self,$count,$line{$title},$line{$number});
	$count++;
    }
}

sub add {
    my $self = shift(@_);
    my $index = shift(@_);
    my $data  = shift(@_);
    my $number = shift(@_);

    ($self->{w_listbox})->insert($index,$data);
    ${$self->{index}}[$index] = $number;
#@index_number = (@index_number[0..$index],$line[0],@index_number[$index+1..$#index_number]);
}

sub button {
    my $self = shift(@_);
    my $index = ($self->{w_listbox})->curselection;
    return ${$self->{index}}[$index];
}

sub duble {
    my $self = shift(@_);
    my $pg   = shift(@_);



    my $space     = shift(@_);
    $space =~ s/^(\s*).*// && do {$space = $1};

    my $pgs = $pg->select("where parent_number = $number");
    my @line = $pgs->get_line;
    while(!$pgs->error) {
	$w_listbox->insert(++$index,"$space  $line[2]");
	push(@numbers,$line[0]);
	@line = $pgs->get_line;
    }
    $sublist{$number} = join(",",@numbers);
}

1;

