###############################################################
# ɥ쥹ɽɥ                                      #
###############################################################
package addres;

sub new {
    my $self = shift(@_);
    $parent = shift(@_);
    $PQconn = shift(@_);

    $pg = Pg_SQL->new($PQconn,addres_db,number,name,furigana,addres,tel,tel2,relation,comment);
    $pg->set_info('title',"ֹ","̾","դ꤬","","","ã","ط","");

    @titles = $pg->get_info('title');
    shift(@titles);

#    $w_top = $parent->Toplevel;
    $w_top = $parent;
    $w_adrlist = $w_top->ScrlListbox('-height'=>14,'-width'=>20);
    $w_adrlist->pack('-side'=>"left");
    $w_adrlist->bind('<Button-1>'=> sub {&view("",$w_adrlist->curselection);});
    $w_view = $w_top->Frame;
    $w_view->pack('-side'=>"right");

    my $count=0;
    foreach $title (@titles) {
	$w_frame = $w_view->Frame;
	$w_frame->pack('-side'=>'top');
	$w_title = $w_frame->Label('-text'=>$title,'-width'=>10,'-anchor'=>nw);
	$w_title->pack('-side'=>left,'-fill'=>x);
	$w_data[$count] = $w_frame->Entry('-width'=>40);
	$w_data[$count]->pack('-side'=>right,'-fill'=>x);
	$count++;
    }
#    $w_data[0]->configure('-state'=>'disabled');

    $w_updown = $w_view->Frame;
    $w_updown->pack('-side'=>'top','-fill'=>x);
    $w_updown->Button('-text'=>"",'-command'=>sub {&add;})->pack('-side'=>left);
    $w_updown->Button('-text'=>"",'-command'=>sub {&modify;})->pack('-side'=>left);
    $w_updown->Button('-text'=>"",'-command'=>sub {&delete})->pack('-side'=>left);
#    $w_updown->Button('-text'=>"λ",'-command'=>sub {undef($main::adr_obj)})->pack('-side'=>left);
    
    &set_listbox("");
    &view("",0);

    bless {};
}

sub set_listbox {
    my $self = shift(@_);
    my $where = shift(@_);
    my $value;

    $w_adrlist->delete(0,end);
    @index_number = ();

    my $count = 0;
    my $pgs = $pg->select("$where");
    while(1) {
	($number,$value) = $pgs->get_line;
	if ($pgs->error) {last;}
	$w_adrlist->insert('end',$value);
	$index_number[$count] = $number;
	$count++;
    }
}

sub view {
    my $self = shift(@_);
    my $index = shift(@_);
    $now_number = $index_number[$index];

    my $pgs = $pg->select("where number = $now_number");
    if ($pgs->error) {return}
    my @nline = $pgs->get_line;
    shift(@nline);

    my $data;
    foreach $w_entry (@w_data) {
	$data = shift(@nline);
	$data =~ s/\s*$//;
	$w_entry->delete(0,end);
	$w_entry->insert(0,$data);
    }
}

sub modify {
    my $self = shift(@_);
    my @data = ();
    my $value;

    foreach $w_entry (@w_data) {
	$value = $w_entry->get;
	$value =~ s/\s*$//;
	push(@data,$value);
    }

    if ($now_number eq "new") {
	my $pgs = $pg->exec("select max(number) from addres_db");
	my ($max_number) = $pgs->get_line;
	$pg->insert(++$max_number,@data);
	if ($pg->error) {print "SQL exec error!!\n";}
	$now_number = $max_number;
    } else {
	$pg->update("where number = $now_number",$now_number,@data);
	if ($pg->error) {print "SQL exec error!!\n";}
    }
    &set_listbox("");
    &view("",,$now_number);
}

sub add {
    my $self = shift(@_);
    $now_number = "new";

    foreach $w_entry (@w_data) {
	$w_entry->delete(0,end);
    }
}

sub delete {
    my $self = shift(@_);
    $pg->exec("delete from addres_db where number = $now_number");
    if ($pg->error) {print "SQL exec error!!\n";}
    &set_listbox("",0);
}

sub DESTROY {
    undef($pg);
    $w_top->destroy;
}

1;
